/* DHT library 
	written by Wraith
   DHT.c:13:5: error: ‘for’ loop initial declarations are only allowed in C99 mode
     for ( uint8_t i = 8; i--; ) {
*/

#include "DHT.h"

char readByte(volatile char* out) {
    unsigned long numloops = 0;
    unsigned long maxloops = 1024; //макс кол-во тиков задержки при 8МГц хватит и 800


    char result = 0;
    for ( uint8_t i = 8; i--; ) {
        // 50 мкс ждем 0
        numloops = 0;
        while (!GET_PORT_DATA(DHT_PORT, DHT_PIN))
            if (++numloops == maxloops)
                return 0;

        // дальше от 27мкс при 0 до 70мкс при 1 - ждем 45 сек и проверяем
        _delay_us(45);

        if (GET_PORT_DATA(DHT_PORT, DHT_PIN))
            result |= 1 << i; 

        // т.к. мы, возможно на 1 - ждем пока она не кончится
        numloops = 0;
        while (GET_PORT_DATA(DHT_PORT, DHT_PIN))
            if (++numloops == maxloops)
                return 0;
    }

    *out = result;
    return 1;
}


char GetDhtData(char *_data) {

  unsigned char i;
  //char res;
  char _lastError = DHT_OK;
  
	  
  //обнуляем данные
 //*_data =*(_data+1) =*(_data+2) =*(_data+3) =*(_data+4) = 0;
	memset(_data,0,5);
	//порт на выход пин в 1 на 250 мсек
	GET_DDR(DHT_PORT) |= (1<<DHT_PIN);
	GET_PORT(DHT_PORT) |= (1<<DHT_PIN);
   _delay_ms(250);

   //пин в 0 на 20 мс
   GET_PORT(DHT_PORT) &= (0<<DHT_PIN);
   _delay_ms(20);

   //порт в 1 на 40 мкс
   GET_PORT(DHT_PORT) |= (1<<DHT_PIN);	
   _delay_us(39);
   
   //порт на вход 
   GET_DDR(DHT_PORT) &= (0<<DHT_PIN);
   GET_PORT(DHT_PORT) &= (0<<DHT_PIN); // Pullup убран!!!
   _delay_us(40);

   //Контроль ответа датчика
   if (GET_PORT_DATA(DHT_PORT, DHT_PIN)) {
     _lastError = DHT_ERROR_START_FAILED_1;
     return _lastError;
   }

   _delay_us(80);

   if (!(GET_PORT_DATA(DHT_PORT, DHT_PIN))) {
     _lastError = DHT_ERROR_START_FAILED_2;
     return _lastError;
   }

   //подождем еще чуть
   _delay_us(40);
   
   cli();

   for (i = 0; i < 5; i++)
        if (!readByte(_data + i))
            _lastError = DHT_ERROR_READ_TIMEOUT;

    sei();
	
	//Порт на выход, пин в 1
    GET_DDR(DHT_PORT) |= (1<<DHT_PIN); 
    GET_PORT(DHT_PORT) |= (1<<DHT_PIN);	


	if (_lastError == DHT_OK ) {
        //Вычисляем контрольную сумму
        if (*(_data+4) != (*_data +*(_data+1) +*(_data+2) +*(_data+3)))
            _lastError = DHT_ERROR_CHECKSUM_FAILURE;
    }

    return _lastError;
 } 
