/* SPI slave Verilog example code. */
`include "dht11.v"
//`include "avr.v"
//`include "avr_ATmega32.v"

`timescale 1ns / 1ps

module test;
   wire [7:0] pa;
   wire [7:0] pb;
   wire [7:0] pc;
   wire [7:0] pd;
   wire       dht_data = pb[4];
   wire       uart_tx = pd[1];
   wire       uart_rx = pd[0];
       
   reg 	      clk = 0;
   // зададим частоту 8МГц,
   always #62.5 clk = ~clk;	// вот тут то и задают период тактового генератора
   
   //pullup(pb[4]);
   
   dht11 DHT(
             .data_io(pb[4])
             );

      
   defparam  avr.progfile="simul.elf";
   ATmega32 avr(clk, pa, pb, pc, pd);
   //avr_clock clock(clk);
   
   initial begin
      //$avr_trace("avr.trace");
      $dumpfile("example.vcd");
      $dumpvars(1, uart_tx, uart_rx, dht_data);
      //$dumpoff;      
      //#1800000000; 		// 1.8 s
      //$display("************ AFTER 1.8 s ***************");
      //$dumpon;
      #500000000; 		// 5 s
      $display("************ AFTER 0.5 s ***************");
      #500000000; 		// 5 s
      $display("************ AFTER 1.0 s ***************");
      // #500000000; 		// 5 s
      // $display("************ AFTER 1.5 s ***************");
      // #500000000; 		// 5 s
      // $display("************ AFTER 2.0 s ***************");
      
      $finish;
   end // initial begin
   
endmodule
// Расчитать правильно частоту, увеличить интервалы? или устроить цикл
// внутри испытаний. Также посмотреть как работать с pullup состоянием?
