`include "dht11.v"

`timescale 100ns/100ns

module dht11tb();
   // Если мое предположение верно то в данном тесте создается
   // двунаправленный провод, затем он соединяется с двунаправленным
   // выводом датчика DHT11 и управляя потоком мы посылаем и принимаем
   // начальные данные.
	
	reg clk = 0;
	always #1 clk = ~clk;

	reg out = 0;
	reg data_reg = 1;
	inout data;
	assign data = (out == 0) ? 1'bZ : data_reg;

	pullup(data);		// Что это?
	dht11 DHT(
		.data_io(data)	// это соединение с data
	);
	
	
	initial
	begin
	   #57; // wait for 5.7us
	   out = 1; // master controls the line
	   #15; // wait for 1.5us
	   data_reg = 0; // switch to req_lo
	   #185000; // wait for 18.5ms
	   data_reg = 1; // switch to initial
	   #400; // wait for 40us
	   data_reg = 0; // switch to req_lo
	   out = 0; // release data line
	end
	
	initial
	begin
		#500000;
		$finish;
	end

endmodule
