/*
 * Прорамма для сбора информации c DHT11 и передачи по uart
 *
 */

//#define F_CPU 8000000L
//#define UBRR 8
//#define UART_SPAM
#include "main.h"

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <inttypes.h>
#include <stdlib.h>
#include <string.h>

#include "DHT.c"
#include "uart.c"

char h[7];
char t[7];

FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

//Функция чтения DHT11
char Read_dht(char *_h, char *_t) {
  char temp[2]={0,0};
  unsigned char i;
  char dht11_dat[5];


  stdout = stderr = stdin = &uart_str;
  for(i=0;i<7;i++) {
	_h[i]=0;
	_t[i]=0;
  }  
  
  switch (GetDhtData(dht11_dat))
    {
    case DHT_OK:
      itoa(dht11_dat[0],temp,10);
      strcpy(_h,temp);
      itoa(dht11_dat[1],temp,10);
      strcat(_h,".");
      strcat(_h,temp);
	
      
      itoa(dht11_dat[2],temp,10);
      strcpy(_t,temp);
      itoa(dht11_dat[3],temp,10);
      strcat(_t,".");
      strcat(_t,temp);
      return 1;
			
    case DHT_ERROR_START_FAILED_1:
      printf("Err:startfail1");
      break;

    case DHT_ERROR_START_FAILED_2:
      printf("Err:startfail2");
      break;

    case DHT_ERROR_READ_TIMEOUT:
      printf("Err:timeout");
      break;
      
    case DHT_ERROR_CHECKSUM_FAILURE:
      printf("Err:checksum");
      break;
    }
  return 0;
}



int main (void)
{
  uart_init();
  stdout = stderr = stdin = &uart_str;
  //_delay_ms(2000); // Время входа в строй датчика DHT11 после включения  
  for (;;){
    if (Read_dht(h,t)) {
      //UART
      printf("Hum: %s  Temp: %s\n",h,t);
      _delay_ms(600);
    }
  }
}
